/******************************************************************************
*                                                                             *
*    Copyright (C) 1992-1995 Tony Robinson                                    *
*                                                                             *
*    See the file LICENSE.shorten for conditions on distribution and usage    *
*                                                                             *
******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "shorten.h"

void *pmalloc(ulong size, shn_file *this_shn) {
  void *ptr;

  ptr = malloc(size);

  if(ptr == NULL)
    fatal_error(this_shn,"Call to malloc(%ld) failed in pmalloc() -\nyour system may be low on memory", size);

  return(ptr);
}

long **long2d(ulong n0, ulong n1, shn_file *this_shn) {
  long **array0 = NULL;

  if((array0 = (long**) pmalloc((ulong) (n0 * sizeof(long*) +
					 n0 * n1 * sizeof(long)),this_shn)) != NULL ) {
    long *array1 = (long*) (array0 + n0);
    int i;

    for(i = 0; i < n0; i++)
      array0[i] = array1 + i * n1;
  }
  return(array0);
}
